/*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||  D E F I N E  :  T E M P E R A T U R |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/

void requestTemperature(DeviceAddress deviceAddress)
{
  // DS18B20 display
  sensors.requestTemperatures(); // Send the command to get temperatures
  
  tempHauptbecken = sensors.getTempC(hauptThermometer);
  tempTechnikbecken = sensors.getTempC(technikThermometer);
  tempPumpe = sensors.getTempC(pumpeThermometer);
  tempLampe = sensors.getTempC(lampeThermometer);

}


String printDouble(double value, byte nachkomma)
{
  String sReturn;

  sReturn = String(int(value));
  if( nachkomma > 0) 
  {
    sReturn += ".";
    unsigned long frac;
    unsigned long mult = 1;
    byte padding = nachkomma -1;
    while(nachkomma--)
      mult *=10;

    if(value >= 0)
      frac = (value - int(value)) * mult;
    else
      frac = (int(value)- value ) * mult;

    unsigned long frac1 = frac;
    while( frac1 /= 10 )
      padding--;

    while(padding--)
      sReturn += "0";

    sReturn += frac;
  }
  return sReturn;
}

int get_key(unsigned int input)
{
  int k;
  for (k = 0; k < NUM_KEYS; k++)
  {
    if (input < adc_key_val[k])
      return k;
  }

  if (k >= NUM_KEYS)
    k = -1;

  return k;
}

int MondPhase(int Year,int Month,int Day)  
{ 
  double M; 
  int XYear,Century; 
  int a;

  if(Month<=2)  
  { 
    Year--; 
    Month+=12; 
  } 

  Month-=3; 
  XYear=Year % 100; 

  a = Year / 100;
  Century=(a*146097) >> 2; 
  XYear=(XYear*1461) >> 2; 

  M=(floor(((((Month*153)+2)/ 5)+Day)+1721119+XYear+Century)+4.867)/29.53058; 
  return int(abs(2*(M-floor(M))-1) * 100); 
} 

//int kalibrieren (long  time, int Kalibrierwert, int Dosiermenge, long Dosierzeit)
int kalibrieren ( int Kalibrierwert, int Dosiermenge, long Dosierzeit )
{
  
  Dosierzeit = ( Dosiermenge * 60 ) / Kalibrierwert;
  return Dosierzeit;
}

/*|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||  D E F I N E  :  B U Z Z E R |||||||||||||||||||||||||||||||||||||||||||||||||||||||||||*/
void buzz(int targetPin, long frequency, long length) {
  long delayValue = 1000000/frequency/2; // calculate the delay value between transitions
  //// 1 second's worth of microseconds, divided by the frequency, then split in half since
  //// there are two phases to each cycle
  long numCycles = frequency * length/ 1000; // calculate the number of cycles for proper timing
  //// multiply frequency, which is really cycles per second, by the number of seconds to 
  //// get the total number of cycles to produce
 for (long i=0; i < numCycles; i++){ // for the calculated length of time...
    digitalWrite(targetPin,HIGH); // write the buzzer pin high to push out the diaphram
    delayMicroseconds(delayValue); // wait for the calculated delay value
    digitalWrite(targetPin,LOW); // write the buzzer pin low to pull back the diaphram
    delayMicroseconds(delayValue); // wait againf or the calculated delay value
  }
}




