int setDisplayInteger (int key, int value, int valueMin, int valueMax, boolean Null, int displayColumn, int displayRow)
{
  switch(key)
  {
  case UPKEY:
    value++;
    if (value > valueMax)
      value = valueMax;
    break;
  case DOWNKEY:
    value--;
    if (value < valueMin)
      value = valueMin;
    break;
  case LEFTKEY:
    value = value - 10;
    if (value < valueMin)
      value = valueMin;
    break;
  case RIGHTKEY:
    value = value + 10;
    if (value > valueMax)
      value = valueMax;
    break;
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  char sValue[4];
  if (Null)
    sprintf(sValue, "%03d", value);
  else
    sprintf(sValue, "%3d", value);  
  lcd.setCursor(displayColumn, displayRow);
  lcd.print (sValue);
  lcd.setCursor(displayColumn + 2,displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("    ");
  }

  return value;
}

Time setDisplayMinute (int key, Time value, int displayColumn, int displayRow)
{
  switch(key)
  {
  case UPKEY:
    value.min++;
      if (value.min == 60)
      { 
        value.min = 0;
      }
    break;
  case DOWNKEY:
    value.min--;
      if (value.min == 255)
      {
        value.min = 59;
      }
    break;
  case LEFTKEY:
    value.min = value.min - 10;
    if (value.min >= 50)
      {
        value.min = 50;
      }
    break;
  case RIGHTKEY:
    value.min = value.min + 10;
    if (value.min >= 60)
      { 
        value.min = 0;
      }
    break;
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  //char sValue[4];
  char sValueMin[1];
//  if (sValueMin)
  sprintf(sValueMin, "%02d", value.min);
//  else
//    sprintf(sValueMin, "%2d", value.min);  
  lcd.setCursor(displayColumn, displayRow);
  lcd.print (sValueMin);
  lcd.setCursor(displayColumn + 1,displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("    ");
  }

  return value;
}

int setDisplayPercent (int key, int value, int valueMin, int valueMax, boolean Null, int displayColumn, int displayRow)
{
  switch(key)
  {
  case UPKEY:
    value++;
    if (value > valueMax)
      value = valueMax;
    break;
  case DOWNKEY:
    value--;
    if (value < valueMin)
      value = valueMin;
    break;
  case LEFTKEY:
    value = value - 10;
    if (value < valueMin)
      value = valueMin;
    break;
  case RIGHTKEY:
    value = value + 10;
    if (value > valueMax)
      value = valueMax;
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  char sValue[6];
  if (Null)
    sprintf(sValue, "%03d %%", value);
  else
    sprintf(sValue, "%3d %%", value);  
  lcd.setCursor(displayColumn, displayRow);
  lcd.print (sValue);
  lcd.setCursor(displayColumn + 2,displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("      ");
  }

  return value;
}

Time setDisplayTime (int key, Time value, int displayColumn, int displayRow)
{
  switch(key)
  {
  case UPKEY:
    if (SetDisplayHelper == 0)
    {
      value.hour++;
      if (value.hour == 24)
        value.hour = 0;
    }
    else
    {
      value.min++;
      if (value.min == 60)
      { 
        value.min = 0;
        value.hour++;
        if (value.hour == 24)
          value.hour = 0;
      }
    }
    break;
  case DOWNKEY:
    if (SetDisplayHelper == 0)
    {
      value.hour--;
      if (value.hour == 255)
        value.hour = 23;
    }    
    else
    {
      value.min--;
      if (value.min == 255)
      {
        value.min = 59;
        value.hour--;
        if (value.hour == 255)
          value.hour = 23; 
      }     
    }
    break;
  case LEFTKEY:
  case RIGHTKEY:
    if (SetDisplayHelper == 0)
      SetDisplayHelper = 1;
    else
      SetDisplayHelper = 0; 
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  char sValueHour[1];
  sprintf(sValueHour, "%02d", value.hour);
  lcd.setCursor(displayColumn, displayRow);
  lcd.print(sValueHour);
  lcd.print(":");  
  lcd.setCursor(displayColumn + 3, displayRow);

  char sValueMin[1];
  sprintf(sValueMin, "%02d", value.min);
  lcd.print(sValueMin);
  if (SetDisplayHelper == 0)
    lcd.setCursor(displayColumn + 1, displayRow);
  else
    lcd.setCursor(displayColumn + 4, displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("     ");
  }

  return value;
}

double setDisplayTemperatur (int key, double value, int displayColumn, int displayRow)
{
  switch(key)
  {
  case UPKEY:
    if (SetDisplayHelper == 0)
    {
      value++;
      if (value > 99)
        value = 99;
    }
    else
    {
      value = value + 0.1;
    }
    break;
  case DOWNKEY:
    if (SetDisplayHelper == 0)
    {
      value--;

      if (value < 10)
        value = 10;
    }    
    else
    {        
      value = value - 0.1;
    }
    break;
  case LEFTKEY:
  case RIGHTKEY:
    if (SetDisplayHelper == 0)
      SetDisplayHelper = 1;
    else
      SetDisplayHelper = 0; 
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  lcd.setCursor(displayColumn, displayRow);
  lcd.print(printDouble(value, 1));
  lcd.setCursor(displayColumn + 4, displayRow);
  lcd.print((char)223);
  lcd.print("C");

  if (SetDisplayHelper)
    lcd.setCursor(displayColumn + 3, displayRow);
  else  
    lcd.setCursor(displayColumn + 1, displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("          ");
  }

  return value;
}

void setDisplayDate (int key, int displayColumn, int displayRow)
{
  Time t = rtc.getTime();
  switch(key)
  {
  case UPKEY:
    if (SetDisplayHelperDate == 0)
      t.date++;
    if (SetDisplayHelperDate == 1)
      t.mon++;
    if (SetDisplayHelperDate == 2)
      t.year++;
    break;
  case DOWNKEY:
    if (SetDisplayHelperDate == 0)
      t.date--;
    if (SetDisplayHelperDate == 1)
      t.mon--;
    if (SetDisplayHelperDate == 2)
      t.year--;
    break;
  case LEFTKEY:
    SetDisplayHelperDate--;
    if (SetDisplayHelperDate == -1)
      SetDisplayHelperDate = 0;
    break;  
  case RIGHTKEY:
    SetDisplayHelperDate++;
    if (SetDisplayHelperDate > 2)
      SetDisplayHelperDate = 2;
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  rtc.setDate (t.date, t.mon, t.year);  
  lcd.setCursor(displayColumn, displayRow);
  lcd.print(rtc.getDateStr()); 

  if (SetDisplayHelperDate == 0)
    lcd.setCursor(displayColumn +1, displayRow);
  if (SetDisplayHelperDate == 1)
    lcd.setCursor(displayColumn +4, displayRow);
  if (SetDisplayHelperDate == 2)
    lcd.setCursor(displayColumn +9, displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("          ");
  }
}

void setDisplayDow (int key, int displayColumn, int displayRow)
{
  Time t = rtc.getTime();
  switch(key)
  {
  case UPKEY:
    if (SetDisplayHelperDate == 0)
      t.dow++;
    break;
  case DOWNKEY:
    if (SetDisplayHelperDate == 0)
      t.dow--;
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  rtc.setDOW (t.dow);  
  lcd.setCursor(displayColumn, displayRow);
  lcd.print(rtc.getDOWStr());
  lcd.print("   ");


  if (SetDisplayHelperDate == 0)
    lcd.setCursor(displayColumn +1, displayRow);
  //  if (SetDisplayHelperDate == 1)
  //    lcd.setCursor(displayColumn +4, displayRow);
  //  if (SetDisplayHelperDate == 2)
  //    lcd.setCursor(displayColumn +9, displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("          ");
  }
}

boolean setDisplayBoolean (int key, boolean value, int displayColumn, int displayRow)
{
  switch(key)
  {
  case UPKEY:
  case DOWNKEY:
    value = !value;
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  lcd.setCursor(displayColumn, displayRow);
  if (value)
    lcd.print("  Ja"); 
  else
    lcd.print("Nein"); 
  lcd.setCursor(displayColumn + 3, displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("    ");
  }

  return value;
}

boolean setDisplayBoolean2 (int key, boolean value, int displayColumn, int displayRow)
{
  switch(key)
  {
  case UPKEY:
  case DOWNKEY:
    value = !value;
    break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  lcd.setCursor(displayColumn, displayRow);
  if (value)
    lcd.print("  An"); 
  else
    lcd.print(" Aus"); 
  lcd.setCursor(displayColumn + 3, displayRow);

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("    ");
  }

  return value;
}


long TimeStamp (int key, int value, long endtime, int displayColumn, int displayRow)
{ 
  switch(key)
  {
  case UPKEY:
  case DOWNKEY:
      endtime = lTime + value;
      break;
  case SELECTKEY:
    MenuTiefe--;
    lcd.noBlink();
    break;
  }

  lcd.setCursor(displayColumn, displayRow);
  lcd.print("Push UP/Down Button"); 

  if (key == SELECTKEY)
  {
    lcd.setCursor(displayColumn, displayRow);
    lcd.print("                    ");
  }
  
  return endtime;

}


void displayHauptmenu(int pos)
{
  lcd.clear();
  lcd.setCursor(0, 0);
  lcd.print(sMenuHaupt[pos]);

  if (pos > 0)
  {
    lcd.setCursor(0, 1);
    lcd.print("<-");  
  }

  if (pos < MENUHAUPT)
  {
    lcd.setCursor(14, 1);
    lcd.print("->");
  }
}

void displayGrundeinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuGrundeinstellung[pos]);
}

void displayLampeneinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuLampeneinstellung[pos]);
}

void M1_displayWeiss(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(M1_sMenuLEDWeiss[pos]);
}

void M1_displayBlau(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(M1_sMenuLEDBlau[pos]);
}

void M1_displayRB(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(M1_sMenuLEDRB[pos]);
}

void M1_displayViolett(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(M1_sMenuLEDViolett[pos]);
}

void M1_displayMond(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(M1_sMenuMond[pos]);
}


void displayTemperatureinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuTemperatureinstellung[pos]);
}

void displayTemp1(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuTemp1[pos]);
}

void displayTemp2(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuTemp2[pos]);
}

void displayTemp3(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuTemp3[pos]);
}

void displayTemp4(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuTemp4[pos]);
}

void displayPumpeneinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuPumpeneinstellung[pos]);
}

void displayPumpe1(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuPumpe1[pos]);
}

void displayPumpe2(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuPumpe2[pos]);
}

void displayPumpe3(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuPumpe3[pos]);
}

void displayPumpe4(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuPumpe4[pos]);
}

void displayPumpe5(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuPumpe5[pos]);
}

void displayAutomatikeinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuAutomatikeinstellungen[pos]);
}

void displayNachfuellautomatik(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuNachfuell[pos]);
}

void displayOsmoseautomatik(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuOsmose[pos]);
}

void displayWasserwechselautomatik(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuWasserwechsel[pos]);
}

void displayFutterautomat(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuFuetterung[pos]);
}

void displayLuefter(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuLuefter[pos]);
}

void displayDosierpumpeneinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuDosierpumpeneinstellung[pos]);
}

void displayDosierer1(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 2);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuDosierer1[pos]);
}

void displayDosierer2(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 2);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuDosierer2[pos]);
}

void displayDosierer3(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 2);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuDosierer3[pos]);
}

void displayDosierer4(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 2);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuDosierer4[pos]);
}

void displayKalkwassereinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 2);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuKalkwassereinstellung[pos]);
}

void displayZeolitheinstellung(int pos)
{
  //lcd.clear();
  lcd.setCursor(0, 1);
  lcd.print("                    ");
  lcd.setCursor(0, 2);
  lcd.print("                    ");
  lcd.setCursor(0, 1);
  lcd.print(sMenuZeolitheinstellung[pos]);
}




